package homework5

import kotlin.random.Random

class GenerationAddressSystem() {
    fun generateRandomPostalCode(): String {
        val postalCodeDigits = List(6) { Random.nextInt(10) }
        return postalCodeDigits.joinToString("")
    }

    fun generateRandomRegion(): String {
        val regions = listOf(
            "Республика Адыгея",
            "Республика Башкортостан",
            "Республика Бурятия",
            "Республика Алтай",
            "Республика Дагестан",
            "Республика Ингушетия",
            "Кабардино-Балкарская Республика",
            "Республика Калмыкия",
            "Карачаево-Черкесская Республика",
            "Республика Карелия",
            "Республика Коми",
            "Республика Марий Эл",
            "Республика Мордовия",
            "Республика Саха (Якутия)",
            "Республика Северная Осетия — Алания",
            "Республика Татарстан",
            "Республика Тыва",
            "Удмуртская Республика",
            "Республика Хакасия",
            "Чеченская Республика",
            "Чувашская Республика",
            "Алтайский край",
            "Краснодарский край",
            "Красноярский край",
            "Приморский край",
            "Ставропольский край",
            "Хабаровский край",
            "Амурская область",
            "Архангельская область",
            "Астраханская область",
            "Белгородская область",
            "Брянская область",
            "Владимирская область",
            "Волгоградская область",
            "Вологодская область",
            "Воронежская область",
            "Ивановская область",
            "Иркутская область",
            "Калининградская область",
            "Калужская область",
            "Камчатский край",
            "Кемеровская область",
            "Кировская область",
            "Костромская область",
            "Курганская область",
            "Курская область",
            "Ленинградская область",
            "Липецкая область",
            "Магаданская область",
            "Московская область",
            "Мурманская область",
            "Нижегородская область",
            "Новгородская область",
            "Новосибирская область",
            "Омская область",
            "Оренбургская область",
            "Орловская область",
            "Пензенская область",
            "Пермский край",
            "Псковская область",
            "Ростовская область",
            "Рязанская область",
            "Самарская область",
            "Саратовская область",
            "Сахалинская область",
            "Свердловская область",
            "Смоленская область",
            "Тамбовская область",
            "Тверская область",
            "Томская область",
            "Тульская область",
            "Тюменская область",
            "Ульяновская область",
            "Челябинская область",
            "Забайкальский край",
            "Ярославская область",
            "г. Москва",
            "г. Санкт-Петербург",
            "Еврейская автономная область",
            "Ненецкий автономный округ",
            "Ханты-Мансийский автономный округ — Югра",
            "Чукотский автономный округ",
            "Ямало-Ненецкий автономный округ",
            "Республика Крым",
            "г. Севастополь"
        )
        return regions.random()
    }

    fun generateRandomCity(): String {
        val cities = listOf(
            "Москва",
            "Санкт-Петербург",
            "Новосибирск",
            "Екатеринбург",
            "Нижний Новгород",
            "Казань",
            "Самара",
            "Омск",
            "Челябинск",
            "Ростов-на-Дону",
            "Уфа",
            "Волгоград",
            "Пермь",
            "Красноярск",
            "Воронеж",
            "Саратов",
            "Краснодар",
            "Тольятти",
            "Ижевск",
            "Барнаул",
            "Ульяновск",
            "Владивосток",
            "Ярославль",
            "Иркутск",
            "Тюмень",
            "Махачкала",
            "Хабаровск",
            "Оренбург",
            "Новокузнецк",
            "Кемерово",
            "Рязань",
            "Томск",
            "Астрахань",
            "Пенза",
            "Липецк",
            "Тула",
            "Киров",
            "Чебоксары",
            "Курск",
            "Магнитогорск",
            "Набережные Челны",
            "Симферополь"
        )
        return cities.random()
    }

    fun generateRandomStreet(): String {
        val streets = listOf(
            "Ленинский проспект",
            "Московская",
            "Пролетарская",
            "Гагарина",
            "Пушкинская",
            "Советская",
            "Красная",
            "Железнодорожная",
            "Парковая",
            "Кирова",
            "Садовая",
            "Маяковского",
            "Набережная",
            "Октябрьская",
            "Первомайская",
            "Комсомольская",
            "Светланская",
            "Победы",
            "Горького",
            "Солнечная",
            "Лесная",
            "Центральная",
            "Полевая",
            "Зеленая",
            "Рабочая",
            "Красноармейская",
            "Спортивная",
            "Мира",
            "Школьная",
            "Горная",
            "Северная",
            "Коммунистическая",
            "Строителей",
            "Песчаная",
            "Кировский проспект",
            "Свободы",
            "Речная",
            "Лермонтова",
            "Интернациональная",
            "Петровская",
            "Ольгинская"
        )
        return streets.random()
    }

    fun generateRandomHouse(): String {
        return Random.nextInt(1, 200).toString()
    }

    fun generateRandomApartment(): String {
        return Random.nextInt(1, 100).toString()
    }

    fun generateAdress(): Address {
        return Address(
            postalCode = generateRandomPostalCode(),
            country = "Россия",
            region = generateRandomRegion(),
            city = generateRandomCity(),
            street = generateRandomStreet(),
            house = generateRandomHouse(),
            apartment = generateRandomApartment()
        )
    }

    fun generateAddress(n: Int): List<Address> {
        val manyAdress = mutableListOf<Address>()

        repeat(n) {
            val address = generateAdress()
            manyAdress.add(address)
        }
        return manyAdress
    }

}
